'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'   Original nur von http://bascom-forum.de
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'
'*******************************************************************************
'auf Treiber IC SSD1963 gendert 26.11.2011
'10.09.2012 angepast fr Display Typ AT070TN90
'Hkipnik@aol.com
'*******************************************************************************

$nocompile

$include "SSD1963_Registers.inc"
'-------------------------------------------------------------------------------
'Config Hardware for Display
'-------------------------------------------------------------------------------
   Cs_disp Alias Portb.0                                    ' /Chip Select Display
      Config Cs_disp = Output
   Res_disp Alias Portb.5                                   ' /Reset Display fr INIT
      Config Res_disp = Output
   Rs_disp Alias Portb.6                                    ' Indexregister = 0, Data = 1
      Config Rs_disp = Output
   Rd_disp Alias Portb.7                                    ' Read = 0, Write = 1
      Config Rd_disp = Output
   Wr_disp Alias Portb.1                                    ' write data to Display
      Config Wr_disp = Output


   Config Vport0 = A
   Data_disp Alias Port0
   Config Porta = Output
   Ddr0 = $ff
                                                         ' Data to Display DB0-DB7
   Config Vport1 = C
   Data_disp_high Alias Port1
   Config Portc = Output
   Ddr1 = $ff
                                                         ' Data to Display DB8-DB15
   Rd_disp = 1
   Cs_disp = 0
   Res_disp = 1
   Wr_disp = 1

#if Use_touch = 1
   Clock Alias Portf.7                                      'XPT2046 Clock Pin
   Cst Alias Portf.4                                        'XPT2046 CS Pin
   Dout Alias Portf.6                                       'XPT2046 Din Pin
   Din Alias Pinf.5                                         'XPT2046 Dout Pin
   Config Din = Input
   Config Clock = Output
   Config Cst = Output
   Config Dout = Output
   Cst = 1

   Dim Touchx As Word
   Dim Touchy As Word
   Dim X_dout As Byte                                       '&B10010101
   X_dout = &HD0                                            '&B10010101
   Dim Y_dout As Byte                                       'H90 = B10010000
   Y_dout = &H90                                            'HD0 = B11010000
   Dim Ende As Byte
#endif
'(
#if Use_touch = 1
' for Hardware Spi
   Cst Alias Portf.4                                        'XPT2046 CS Pin
   Config Cst = Output                                      'TDO = Miso D6 - TDI = Mosi D5 - TSCK = Clock D7 fr spiD
   Cst = 1
   Config Spif = Hard , Master = Yes , Mode = 0 , Clockdiv = Clk128 , Data_order = Msb
   Open "SPIF" For Binary As #14
   Dim Touchx As Word
   Dim Touchy As Word
   Dim X_dout As Byte                                       '&B10010101
   X_dout = &HD0                                            '&B10010101
   Dim Y_dout As Byte                                       'H90 = B10010000
   Y_dout = &H90                                            'HD0 = B11010000

   Dim Ende As Byte
#endif
')

Const Pi = 3.14159265358979
Dim Move_x As Word , Move_y As Word , Out_of_range As Byte

'-------------------------------------------------------------------------------
'pre define Colors
'-------------------------------------------------------------------------------
 Dim Rgb16 As Word
 Dim Rgb16_low As Byte At Rgb16 Overlay
 Dim Rgb16_high As Byte At Rgb16 + 1 Overlay

Dim Color_array(10) As Word
Color_array(1) = &HF800
Color_array(2) = &H0400
Color_array(3) = &H001F
Color_array(4) = &HFFFF
Color_array(5) = &H07FF
Color_array(6) = &HF81F
Color_array(7) = &HA145
Color_array(8) = &HFD20
Color_array(9) = &HFE19
Color_array(10) = &HEC1D

Const Transparent = &H1000
Const Red = &HF800
Const Green = &H0400
Const Blue = &H001F
Const White = &HFFFF
Const Black = &H0000
Const Yellow = &HFFE0
Const Cyan = &H07FF
Const Magenta = &HF81F
Const Brown = &HA145
Const Olive = &H8400
Const Orange = &HFD20
Const Violet = &HEC1D
Const Gold = &HFEA0
Const Chocolate = &HD343
Const Darkgreen = &H0320
Const Darkred = &H8800
Const Darkblue = &H0011
Const Navi = &H0010
Const Steelblue = &H4416
Const Beige = &HF7BB

Dim X_pixel As Word , Y_pixel As Word

'-------------------------------------------------------------------------------
' Declarations SUB, FUNCTIONS
'-------------------------------------------------------------------------------
Declare Sub Ssd1963_init()
Declare Sub Ssd1963_write_reg(byval Index As Byte , Byval Daten As Word)
Declare Sub Ssd1963_select_reg(byval Index As Byte )

Declare Sub Ssd1963_write_data(byval Daten As Byte)
Declare Sub Ssd1963_16data(byval Rgb As Word)

Declare Sub Lcd_set_cursor(byval X As Word , Byval Y As Word )
Declare Sub Lcd_clear(byval Color As Word)
Declare Sub Lcd_text(byval Lcd_text As String , Byval Lcd_posx As Word , Byval Lcd_posy As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word)
Declare Sub Lcd_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_set_pixel(byval X1 As Word , Byval Y1 As Word , Byval Color As Word)
Declare Sub Lcd_box(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Fill_color As Word , Byval Border_color As Word , Byval Fill As Byte , Byval Show_border As Byte)
Declare Function Lcd_trigfunctiony(byval Pointratio As Single)as Single
Declare Function Lcd_trigfunctionx(byval Pointratio As Single) As Single
Declare Sub Lcd_drawcircle(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Sides As Word , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_fill_circle(byval X As Word , Byval Y As Word , Byval Radius As Word , Byval Color1 As Word)
Declare Sub Lcd_lineto(byval X As Word , Byval Y As Word , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_moveto(byval X As Word , Byval Y As Word)
Declare Sub Lcd_drawarc(byval Centerx As Word , Byval Centery As Word , Byval Radius As Word , Byval Startangle As Word , Byval Arcangle As Word , Byval Steps As Word , Byval Pen_width As Byte , Byval Color As Word)
Declare Sub Lcd_draw_bmp(byval Filename As String , Byval Xpos As Word , Byval Ypos As Word)
Declare Sub Lcd_set_window(byval Xpos As Word , Byval Ypos As Word , Byval Xsize As Word , Byval Ysize As Word)
Declare Sub Lcd_scroll(byval Lines As Word )
Declare Sub Lcd_negate(byval Art As Word )
Declare Sub Lcd_setscrollarea(byval Top As Word , Byval Scroll As Word , Byval Bottom As Word)
Declare Sub Lcd_text_trans(byval S As String , Byval Xoffset As Word , Byval Yoffset As Word , Byval Fontset As Byte , Byval Forecolor As Word , Byval Backcolor As Word )
Declare Sub Lcd_clear_area(byval Xs As Word , Byval Ys As Word , Byval Xlength As Word , Byval Ylength As Word , Byval Color As Word)


#if Use_touch = 1
Declare Sub Lcd_read_touch()
#endif